BLANC, GRIS, NOIR = 0, 1, 2

def parcours_cycle(G, depart, couleurs):
    """ Graphe, Sommet, {Sommet:Couleur} -> bool
    Renvoie True si et seulement si  il existe un cycle dans le graphe G dans la composante connexe de depart. 
    On suppose que depart est en BLANC. """
    couleurs[...] = GRIS
    for destination in G.voisins(depart):
        if ...:
            return ...
        elif ...
            return ...
    couleurs[...] = ...
    return ...
